<?php

namespace FiloBlu\Countdown\Ui\Component\Listing\Column;

use Magento\Store\Model\StoreManagerInterface;

class Video extends \Magento\Ui\Component\Listing\Columns\Column
{

    public function __construct(
        \Magento\Framework\View\Element\UiComponent\ContextInterface $context,
        \Magento\Framework\View\Element\UiComponentFactory $uiComponentFactory,
        StoreManagerInterface $storeManager,
        array $components = [],
        array $data = []
    )
    {
        $this->storeManager = $storeManager;

        parent::__construct($context, $uiComponentFactory, $components, $data);
    }

    public function prepareDataSource(array $dataSource)
    {
        if (isset($dataSource['data']['items'])) {

            $fieldName = $this->getData('name');
            foreach ($dataSource['data']['items'] as & $item) {

                $url = '';
                if ($item[$fieldName] != '') {
                    $url = $this->storeManager->getStore()->getBaseUrl(
                            \Magento\Framework\UrlInterface::URL_TYPE_MEDIA
                        ) . 'filoblu/countdown' . $item[$fieldName];
                }
                if ($url) {
                    $item[$fieldName] = '<video width="130px" autoplay muted loop><source src="' . $url . '" type="video/mp4"></video>';
                } else {
                    $item[$fieldName] = '';
                }


            }
        }

        return $dataSource;
    }
}